<?php

namespace Scheduler\Logic;
require_once "consumer.php";
require_once "MailSender.php";
require_once "JobDeleter.php";




class ConsumerOnDemand
{

    public static function consumeTrigger($param)
    {

        if($param==70){
            echo '<strong>Nenhum parâmetro foi passado.</strong>';
            die;
        }
        register_shutdown_function(Array('\Scheduler\Logic\ConsumerOnDemand','checkForFatalError'), $param);

        try{
            \Scheduler\Logic\Consumer::executeProcess(addslashes(trim($param)));
        }
        //se for um ConsumerException, é porquê deu algo errado com o job em si
        catch (\Scheduler\Logic\ConsumerException $e) {
            ConsumerOnDemand::handleError($e->getJobId(), $e->getMessage());
        }
        //se não, aconteceu algo fora do job (e.g. o banco caiu e não conseguiu pegar os jobs a serem executados)
        catch (\Exception $e) {
            \Scheduler\Logic\MailSender::sendErrorEmail($e->getMessage());
        }
    }

    public static function checkForFatalError($id)
    {
        if (@is_array($e = @error_get_last()) && ($e['type'] === E_ERROR || $e['type'] === E_USER_ERROR)) {
            try{
                $file = isset($e['file']) ? $e['file'] : '';
                $line = isset($e['line']) ? $e['line'] : '';
                $msg = "Fatal - " . (isset($e['message']) ? $e['message'] : '');
                $msg .= " at {$file}({$line}).";
                ConsumerOnDemand::handleError($id, $msg);
            }
            catch(\Exception $e){
                \Scheduler\Logic\MailSender::sendErrorEmail("Erro: " . $e->getMessage());
            }
        }
    }


    public static function handleError($id, $msg)
    {
        \Scheduler\Logic\MailSender::sendErrorEmail($msg);
        $hasExpired=\Scheduler\Logic\Consumer::checkProcessFailure($id);
        if($hasExpired){
            \Scheduler\Logic\JobDeleter::deleteJob($id);
        }
    }

}
isset($_GET['proc']) ? $param=$_GET['proc'] : $param=70;
ConsumerOnDemand::consumeTrigger($param);


