CREATE OR REPLACE FUNCTION ARQUIVO_DPI_MOVCFOP(
   P_CDIMPOSTO    IN IMPOSTO.CDIMPOSTO%TYPE,
   P_CDEMPRESA    IN EMPRESA.CDEMPRESA%TYPE,
   P_DTINICIAL    IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_DTFINAL      IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_CDINSCESTA   IN NOTAFISCAL.CDINSCESTA%TYPE,
   P_CONTADOR     IN NUMBER,
   P_SEQMAGNET    IN VARCHAR)
RETURN NUMBER
AS
   V_CONTADOR     NUMBER;
   V_CDIMPOSTRIB  VARCHAR2(2);
BEGIN
   V_CONTADOR := NVL(P_CONTADOR,0);

   /* IMPOSTO COM SUBSTITUIO TRIBUTRIA */
   V_CDIMPOSTRIB := '80';

   FOR C_REGISTRO_02 IN(
      SELECT I.CDFISCOPERNF
             ||'~'||
             SUM(I.VRCONTITIMP)
             ||'~'||
             SUM(I.VRBASECALCNF)
             ||'~'||
             SUM(I.VRIMPOSTONF)
             ||'~'||
             ROUND(SUM(I.VRPERREDBCNF),2)
             ||'~'||
             SUM(I.ISENTAS)
             ||'~0~'||
             SUM(I.SUBST)
             ||'~'||
             SUM(I.OUTRAS)||'~' AS REGISTRO_02
        FROM (

             SELECT L.CDFISCOPERNF AS CDFISCOPERNF,
                    SUM(DECODE(T.NRITPROIMPOS,1,T.VRCONTITIMP,2,T.VRCONTITIMP,0)) AS VRCONTITIMP,
                    SUM(DECODE(T.NRITPROIMPOS,1,DECODE(CDFISCALIT,1,T.VRBASECALCIT,0),0)) AS VRBASECALCNF,
                    SUM(DECODE(T.NRITPROIMPOS,1,DECODE(CDFISCALIT,1,T.VRIMPOSTOIT,0),0))  AS VRIMPOSTONF,
                    SUM(DECODE(T.NRITPROIMPOS,2,VRCONTITIMP,0))AS VRPERREDBCNF,
                    SUM(DECODE(T.NRITPROIMPOS,2,0,CASE WHEN T.CDFISCALIT = '2' THEN T.VRCONTITIMP ELSE 0 END ))AS ISENTAS,
                    SUM(DECODE(T.NRITPROIMPOS,1,VALOR_IMPOSTO_NFE(N.CDFILIAL,N.NRLANCTONF,V_CDIMPOSTRIB,'C'),0)) AS SUBST,
                    SUM(DECODE(T.CDFISCALIT,3,T.VRCONTITIMP,0)) AS OUTRAS
               FROM NOTAFISCAL N,CLIENTE C,ITEMPRODUTO P,ITEMPROIMPOS T, IMPOSTO IP,
                    (SELECT I.CDFISCOPERNF AS CDFISCOPERNF,
                            I.CDFILIAL AS CDFILIAL,
                            I.NRLANCTONF AS NRLANCTONF,
                            IM.CDIMPOSTONFE AS CDIMPOSTO
                       FROM MAPAAPURAC M,IMPOSTONF I, IMPOSTO IM
                      WHERE M.CDEMPRESA     = P_CDEMPRESA
                        AND M.CDINSCESTA    = P_CDINSCESTA
                        AND M.CDIMPOSTO     = P_CDIMPOSTO
                        AND M.DTINIPERIODO >= P_DTINICIAL
                        AND M.DTFIMPERIODO <= P_DTFINAL
                        AND M.NRSEQUMAPAPU  = I.NRSEQUMAPAPU
                        AND M.CDIMPOSTO     = IM.CDIMPOSTONFE
                        AND IM.CDIMPOSTO    = I.CDIMPOSTO
                        AND (IDIMPOSTONF <> '3' OR IDIMPOSTONF IS NULL)
                      GROUP BY I.CDFISCOPERNF, I.CDFILIAL, I.NRLANCTONF, IM.CDIMPOSTONFE )L
              WHERE L.CDFILIAL      = N.CDFILIAL
                AND L.NRLANCTONF    = N.NRLANCTONF
                AND N.CDFILIAL      = P.CDFILIAL
                AND N.NRLANCTONF    = P.NRLANCTONF
                AND P.CDFILIAL      = T.CDFILIAL
                AND P.NRLANCTONF    = T.NRLANCTONF
                AND P.NRSEQITPROD   = T.NRSEQITPROD
                AND IP.CDIMPOSTONFE = L.CDIMPOSTO
                AND IP.CDIMPOSTO    = T.CDIMPOSTO
                AND N.CDCLIENTE     = C.CDCLIENTE
                AND N.IDENTRSAIDOP  = 'E'
                AND IDORIGDESTNF    = 'C'
              GROUP BY L.CDFISCOPERNF
             UNION ALL
             SELECT L.CDFISCOPERNF AS CDFISCOPERNF,
                    SUM(DECODE(T.NRITPROIMPOS,1,T.VRCONTITIMP,2,T.VRCONTITIMP,0)) AS VRCONTITIMP,
                    SUM(DECODE(T.NRITPROIMPOS,1,DECODE(CDFISCALIT,1,T.VRBASECALCIT,0),0)) AS VRBASECALCNF,
                    SUM(DECODE(T.NRITPROIMPOS,1,DECODE(CDFISCALIT,1,T.VRIMPOSTOIT,0),0))  AS VRIMPOSTONF,
                    SUM(DECODE(T.NRITPROIMPOS,2,VRCONTITIMP,0))AS VRPERREDBCNF,
                    SUM(DECODE(T.NRITPROIMPOS,2,0,CASE WHEN T.CDFISCALIT = '2' THEN T.VRCONTITIMP ELSE 0 END ))AS ISENTAS,
                    SUM(DECODE(T.NRITPROIMPOS,1,VALOR_IMPOSTO_NFE(N.CDFILIAL,N.NRLANCTONF,V_CDIMPOSTRIB,'C'),0)) AS SUBST,
                    SUM(DECODE(T.CDFISCALIT,3,T.VRCONTITIMP,0)) AS OUTRAS
               FROM NOTAFISCAL N, FILIAL F, ITEMPRODUTO P, ITEMPROIMPOS T, IMPOSTO IP,
                    (SELECT I.CDFISCOPERNF AS CDFISCOPERNF,
                            I.CDFILIAL AS CDFILIAL,
                            I.NRLANCTONF AS NRLANCTONF,
                            IM.CDIMPOSTONFE AS CDIMPOSTO
                       FROM MAPAAPURAC M, IMPOSTONF I, IMPOSTO IM
                      WHERE M.CDEMPRESA     = P_CDEMPRESA
                        AND M.CDINSCESTA    = P_CDINSCESTA
                        AND M.CDIMPOSTO     = P_CDIMPOSTO
                        AND M.DTINIPERIODO >= P_DTINICIAL
                        AND M.DTFIMPERIODO <= P_DTFINAL
                        AND M.NRSEQUMAPAPU  = I.NRSEQUMAPAPU
                        AND M.CDIMPOSTO     = IM.CDIMPOSTONFE
                        AND IM.CDIMPOSTO    = I.CDIMPOSTO
                        AND (IDIMPOSTONF <> '3' OR IDIMPOSTONF IS NULL)
                      GROUP BY I.CDFISCOPERNF, I.CDFILIAL, I.NRLANCTONF, IM.CDIMPOSTONFE )L
              WHERE L.CDFILIAL      = N.CDFILIAL
                AND L.NRLANCTONF    = N.NRLANCTONF
                AND N.CDFILIAL      = P.CDFILIAL
                AND N.NRLANCTONF    = P.NRLANCTONF
                AND P.CDFILIAL      = T.CDFILIAL
                AND P.NRLANCTONF    = T.NRLANCTONF
                AND P.NRSEQITPROD   = T.NRSEQITPROD
                AND IP.CDIMPOSTONFE = L.CDIMPOSTO
                AND IP.CDIMPOSTO    = T.CDIMPOSTO
                AND N.CDFILIRECE    = F.CDFILIAL
                AND N.IDENTRSAIDOP  = 'E'
                AND IDORIGDESTNF    = 'L'
              GROUP BY L.CDFISCOPERNF
             UNION ALL
             SELECT L.CDFISCOPERNF AS CDFISCOPERNF,
                    SUM(DECODE(T.NRITPROIMPOS,1,T.VRCONTITIMP,2,T.VRCONTITIMP,0)) AS VRCONTITIMP,
                    SUM(DECODE(T.NRITPROIMPOS,1,DECODE(CDFISCALIT,1,T.VRBASECALCIT,0),0)) AS VRBASECALCNF,
                    SUM(DECODE(T.NRITPROIMPOS,1,DECODE(CDFISCALIT,1,T.VRIMPOSTOIT,0),0))  AS VRIMPOSTONF,
                    SUM(DECODE(T.NRITPROIMPOS,2,VRCONTITIMP,0))AS VRPERREDBCNF,
                    SUM(DECODE(T.NRITPROIMPOS,2,0,CASE WHEN T.CDFISCALIT = '2' THEN T.VRCONTITIMP ELSE 0 END ))AS ISENTAS,
                    SUM(DECODE(T.NRITPROIMPOS,1,VALOR_IMPOSTO_NFE(N.CDFILIAL,N.NRLANCTONF,V_CDIMPOSTRIB,'C'),0)) AS SUBST,
                    SUM(DECODE(T.CDFISCALIT,3,T.VRCONTITIMP,0)) AS OUTRAS
               FROM NOTAFISCAL N,FORNECEDOR F,ITEMPRODUTO P,ITEMPROIMPOS T, IMPOSTO IP,
                    (SELECT I.CDFISCOPERNF AS CDFISCOPERNF,
                            I.CDFILIAL AS CDFILIAL,
                            I.NRLANCTONF AS NRLANCTONF,
                            IM.CDIMPOSTONFE AS CDIMPOSTO
                       FROM MAPAAPURAC M, IMPOSTONF I, IMPOSTO IM
                      WHERE M.CDEMPRESA     = P_CDEMPRESA
                        AND M.CDINSCESTA    = P_CDINSCESTA
                        AND M.CDIMPOSTO     = P_CDIMPOSTO
                        AND M.DTINIPERIODO >= P_DTINICIAL
                        AND M.DTFIMPERIODO <= P_DTFINAL
                        AND M.NRSEQUMAPAPU  = I.NRSEQUMAPAPU
                        AND M.CDIMPOSTO     = IM.CDIMPOSTONFE
                        AND IM.CDIMPOSTO    = I.CDIMPOSTO
                        AND (IDIMPOSTONF <> '3' OR IDIMPOSTONF IS NULL)
                      GROUP BY I.CDFISCOPERNF, I.CDFILIAL, I.NRLANCTONF, IM.CDIMPOSTONFE )L
              WHERE L.CDFILIAL      = N.CDFILIAL
                AND L.NRLANCTONF    = N.NRLANCTONF
                AND N.CDFILIAL      = P.CDFILIAL
                AND N.NRLANCTONF    = P.NRLANCTONF
                AND P.CDFILIAL      = T.CDFILIAL
                AND P.NRLANCTONF    = T.NRLANCTONF
                AND P.NRSEQITPROD   = T.NRSEQITPROD
                AND IP.CDIMPOSTONFE = L.CDIMPOSTO
                AND IP.CDIMPOSTO    = T.CDIMPOSTO
                AND N.CDFORNECED    = F.CDFORNECED
                AND N.IDENTRSAIDOP  = 'E'
                AND IDORIGDESTNF    = 'F'
              GROUP BY L.CDFISCOPERNF
             UNION ALL
             SELECT L.CDFISCOPERNF AS CDFISCOPERNF,
                    SUM(DECODE(T.NRITPROIMPOS,1,T.VRCONTITIMP,2,T.VRCONTITIMP,0)) AS VRCONTITIMP,
                    SUM(DECODE(T.NRITPROIMPOS,1,DECODE(CDFISCALIT,1,T.VRBASECALCIT,0),0)) AS VRBASECALCNF,
                    SUM(DECODE(T.NRITPROIMPOS,1,DECODE(CDFISCALIT,1,T.VRIMPOSTOIT,0),0))  AS VRIMPOSTONF,
                    SUM(DECODE(T.NRITPROIMPOS,2,VRCONTITIMP,0))AS VRPERREDBCNF,
                    SUM(DECODE(T.NRITPROIMPOS,2,0,CASE WHEN T.CDFISCALIT = '2' THEN T.VRCONTITIMP ELSE 0 END ))AS ISENTAS,
                    SUM(DECODE(T.NRITPROIMPOS,1,VALOR_IMPOSTO_NFE(N.CDFILIAL,N.NRLANCTONF,V_CDIMPOSTRIB,'C'),0)) AS SUBST,
                    SUM(DECODE(T.CDFISCALIT,3,T.VRCONTITIMP,0)) AS OUTRAS
               FROM NOTAFISCAL N,FORNECEDOR F,ITEMPRODUTO P,ITEMPROIMPOS T, IMPOSTO IP,
                    (SELECT I.CDFISCOPERNF AS CDFISCOPERNF,
                            I.CDFILIAL AS CDFILIAL,
                            I.NRLANCTONF AS NRLANCTONF,
                            IM.CDIMPOSTONFE AS CDIMPOSTO
                       FROM MAPAAPURAC M, IMPOSTONF I, IMPOSTO IM
                      WHERE M.CDEMPRESA     = P_CDEMPRESA
                        AND M.CDINSCESTA    = P_CDINSCESTA
                        AND M.CDIMPOSTO     = P_CDIMPOSTO
                        AND M.DTINIPERIODO >= P_DTINICIAL
                        AND M.DTFIMPERIODO <= P_DTFINAL
                        AND M.NRSEQUMAPAPU  = I.NRSEQUMAPAPU
                        AND M.CDIMPOSTO     = IM.CDIMPOSTONFE
                        AND IM.CDIMPOSTO    = I.CDIMPOSTO
                        AND (IDIMPOSTONF <> '3' OR IDIMPOSTONF IS NULL)
                      GROUP BY I.CDFISCOPERNF, I.CDFILIAL, I.NRLANCTONF, IM.CDIMPOSTONFE )L
              WHERE L.CDFILIAL      = N.CDFILIAL
                AND L.NRLANCTONF    = N.NRLANCTONF
                AND N.CDFILIAL      = P.CDFILIAL
                AND N.NRLANCTONF    = P.NRLANCTONF
                AND P.CDFILIAL      = T.CDFILIAL
                AND P.NRLANCTONF    = T.NRLANCTONF
                AND P.NRSEQITPROD   = T.NRSEQITPROD
                AND IP.CDIMPOSTONFE = L.CDIMPOSTO
                AND IP.CDIMPOSTO    = T.CDIMPOSTO
                AND N.CDFORNECED    = F.CDFORNECED
                AND N.IDENTRSAIDOP  = 'S'
                AND IDORIGDESTNF    = 'F'
              GROUP BY L.CDFISCOPERNF
              UNION ALL
             SELECT L.CDFISCOPERNF AS CDFISCOPERNF,
                    SUM(DECODE(T.NRITPROIMPOS,1,T.VRCONTITIMP,2,T.VRCONTITIMP,0)) AS VRCONTITIMP,
                    SUM(DECODE(T.NRITPROIMPOS,1,DECODE(CDFISCALIT,1,T.VRBASECALCIT,0),0)) AS VRBASECALCNF,
                    SUM(DECODE(T.NRITPROIMPOS,1,DECODE(CDFISCALIT,1,T.VRIMPOSTOIT,0),0))  AS VRIMPOSTONF,
                    SUM(DECODE(T.NRITPROIMPOS,2,VRCONTITIMP,0))AS VRPERREDBCNF,
                    SUM(DECODE(T.NRITPROIMPOS,2,0,CASE WHEN T.CDFISCALIT = '2' THEN T.VRCONTITIMP ELSE 0 END ))AS ISENTAS,
                    SUM(DECODE(T.NRITPROIMPOS,1,VALOR_IMPOSTO_NFE(N.CDFILIAL,N.NRLANCTONF,V_CDIMPOSTRIB,'C'),0)) AS SUBST,
                    SUM(DECODE(T.CDFISCALIT,3,T.VRCONTITIMP,0)) AS OUTRAS
               FROM NOTAFISCAL N,CLIENTE C,ITEMPRODUTO P,ITEMPROIMPOS T, IMPOSTO IP,
                    (SELECT I.CDFISCOPERNF AS CDFISCOPERNF,
                            I.CDFILIAL AS CDFILIAL,
                            I.NRLANCTONF AS NRLANCTONF,
                            IM.CDIMPOSTONFE AS CDIMPOSTO
                       FROM MAPAAPURAC M,IMPOSTONF I, IMPOSTO IM
                      WHERE M.CDEMPRESA     = P_CDEMPRESA
                        AND M.CDINSCESTA    = P_CDINSCESTA
                        AND M.CDIMPOSTO     = P_CDIMPOSTO
                        AND M.DTINIPERIODO >= P_DTINICIAL
                        AND M.DTFIMPERIODO <= P_DTFINAL
                        AND M.NRSEQUMAPAPU  = I.NRSEQUMAPAPU
                        AND M.CDIMPOSTO     = IM.CDIMPOSTONFE
                        AND IM.CDIMPOSTO    = I.CDIMPOSTO
                        AND (IDIMPOSTONF <> '3' OR IDIMPOSTONF IS NULL)
                      GROUP BY I.CDFISCOPERNF, I.CDFILIAL, I.NRLANCTONF, IM.CDIMPOSTONFE )L
              WHERE L.CDFILIAL      = N.CDFILIAL
                AND L.NRLANCTONF    = N.NRLANCTONF
                AND N.CDFILIAL      = P.CDFILIAL
                AND N.NRLANCTONF    = P.NRLANCTONF
                AND P.CDFILIAL      = T.CDFILIAL
                AND P.NRLANCTONF    = T.NRLANCTONF
                AND P.NRSEQITPROD   = T.NRSEQITPROD
                AND IP.CDIMPOSTONFE = L.CDIMPOSTO
                AND IP.CDIMPOSTO    = T.CDIMPOSTO
                AND N.CDCLIENTE     = C.CDCLIENTE
                AND N.IDENTRSAIDOP  = 'S'
                AND IDORIGDESTNF    = 'C'
              GROUP BY L.CDFISCOPERNF
              UNION ALL
             SELECT L.CDFISCOPERNF AS CDFISCOPERNF,
                    SUM(DECODE(T.NRITPROIMPOS,1,T.VRCONTITIMP,2,T.VRCONTITIMP,0)) AS VRCONTITIMP,
                    SUM(DECODE(T.NRITPROIMPOS,1,DECODE(CDFISCALIT,1,T.VRBASECALCIT,0),0)) AS VRBASECALCNF,
                    SUM(DECODE(T.NRITPROIMPOS,1,DECODE(CDFISCALIT,1,T.VRIMPOSTOIT,0),0))  AS VRIMPOSTONF,
                    SUM(DECODE(T.NRITPROIMPOS,2,VRCONTITIMP,0))AS VRPERREDBCNF,
                    SUM(DECODE(T.NRITPROIMPOS,2,0,CASE WHEN T.CDFISCALIT = '2' THEN T.VRCONTITIMP ELSE 0 END ))AS ISENTAS,
                    SUM(DECODE(T.NRITPROIMPOS,1,VALOR_IMPOSTO_NFE(N.CDFILIAL,N.NRLANCTONF,V_CDIMPOSTRIB,'C'),0)) AS SUBST,
                    SUM(DECODE(T.CDFISCALIT,3,T.VRCONTITIMP,0)) AS OUTRAS
               FROM NOTAFISCAL N,FILIAL F,ITEMPRODUTO P,ITEMPROIMPOS T, IMPOSTO IP,
                    (SELECT I.CDFISCOPERNF AS CDFISCOPERNF,
                            I.CDFILIAL AS CDFILIAL,
                            I.NRLANCTONF AS NRLANCTONF,
                            IM.CDIMPOSTONFE AS CDIMPOSTO
                       FROM MAPAAPURAC M,IMPOSTONF I, IMPOSTO IM
                      WHERE M.CDEMPRESA     = P_CDEMPRESA
                        AND M.CDINSCESTA    = P_CDINSCESTA
                        AND M.CDIMPOSTO     =  P_CDIMPOSTO
                        AND M.DTINIPERIODO >= P_DTINICIAL
                        AND M.DTFIMPERIODO <=  P_DTFINAL
                        AND M.NRSEQUMAPAPU  = I.NRSEQUMAPAPU
                        AND M.CDIMPOSTO     = IM.CDIMPOSTONFE
                        AND IM.CDIMPOSTO    = I.CDIMPOSTO
                        AND (IDIMPOSTONF <> '3' OR IDIMPOSTONF IS NULL)
                      GROUP BY I.CDFISCOPERNF, I.CDFILIAL, I.NRLANCTONF, IM.CDIMPOSTONFE )L
              WHERE L.CDFILIAL      = N.CDFILIAL
                AND L.NRLANCTONF    = N.NRLANCTONF
                AND N.CDFILIAL      = P.CDFILIAL
                AND N.NRLANCTONF    = P.NRLANCTONF
                AND P.CDFILIAL      = T.CDFILIAL
                AND P.NRLANCTONF    = T.NRLANCTONF
                AND P.NRSEQITPROD   = T.NRSEQITPROD
                AND IP.CDIMPOSTONFE = L.CDIMPOSTO
                AND IP.CDIMPOSTO    = T.CDIMPOSTO
                AND N.CDFILIEMIT    = F.CDFILIAL
                AND N.IDENTRSAIDOP  = 'S'
                AND IDORIGDESTNF    = 'L'
              GROUP BY L.CDFISCOPERNF)I
       GROUP BY I.CDFISCOPERNF) LOOP

    V_CONTADOR := NVL(V_CONTADOR,0)+1;
    INSERT INTO ARQMAGNETICO
       (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
       VALUES
       ('2'||LPAD(V_CONTADOR, 9, '0'),C_REGISTRO_02.REGISTRO_02,P_SEQMAGNET);
   END LOOP;

RETURN (LPAD(V_CONTADOR, 10, 0));
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ARQUIVO_DPI_MOVCFOP','5.30.000'); END;
/

