CREATE OR REPLACE FUNCTION ARQUIVO_GIA_MS_03(
   P_CDEMPRESA   IN EMPRESA.CDEMPRESA%TYPE,
   P_CDINSCESTA  IN NOTAFISCAL.CDINSCESTA%TYPE,
   P_CDIMPOSTO   IN IMPOSTO.CDIMPOSTO%TYPE,
   P_DTINICIAL   IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_DTFINAL     IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_TPDEC       IN VARCHAR,
   P_PDEC        IN VARCHAR,
   P_CONTADOR    IN VARCHAR,
   P_SEQMAGNET   IN VARCHAR)
RETURN VARCHAR
AS
   V_INSERT        VARCHAR2(100);
   V_CDIMPOSTRIB   VARCHAR2(2);
   V_MESINI        VARCHAR2(2);
   V_CONTADOR      NUMBER;
   V_VERIFICA      VARCHAR2(1);
BEGIN
   V_CONTADOR := NVL(P_CONTADOR,0);
   V_VERIFICA := '0';
   /* BUSCA O IMPOSTO COM SUBSTITUIO TRIBUTRIA */
   BEGIN
      SELECT MAX(CDIMPOSTRIB)
        INTO V_CDIMPOSTRIB
        FROM IMPOSTO
       WHERE CDIMPOSTONFE = P_CDIMPOSTO;
   EXCEPTION WHEN  NO_DATA_FOUND THEN
      V_CDIMPOSTRIB := NULL;
   END;

   IF P_PDEC = '2' THEN
      V_MESINI := '00';
   ELSE
      V_MESINI := TO_CHAR(P_DTINICIAL,'MM');
   END IF;

   V_INSERT := SUBSTR(RPAD(REPLACE(REPLACE(REPLACE(NVL(P_CDINSCESTA, ' '),'.',''),'-',''),'ISENT','ISENTO'),9,' '),1,9)
               ||TO_CHAR(P_DTINICIAL,'YYYY')
               ||V_MESINI
               ||TO_CHAR(P_DTFINAL,'MM')
               ||P_TPDEC
               ||'03';

   IF V_CDIMPOSTRIB IS NOT NULL THEN
      FOR C_REGISTRO_03 IN(
         SELECT LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(SUM(NVL(VRTTBACALDEB,0)),2),'9999999999990.00')),'.',''),15,0)
                ||LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(SUM(NVL(VRTOTADEBI,0)),2),'9999999999990.00')),'.',''),15,0)
                ||LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(SUM(NVL(VRSLDCRANTE,0)),2),'9999999999990.00')),'.',''),15,0)
                ||LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(SUM(NVL(I.VRIMPOSTONF,0)),2),'9999999999990.00')),'.',''),15,0)
                ||LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(SUM(NVL(VRTOTAIMPOS,0)),2),'9999999999990.00')),'.',''),15,0)
                ||LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(SUM(NVL(VRSALDOCRED,0)),2),'9999999999990.00')),'.',''),15,0)
                ||LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(SUM(NVL(VROUTRCRED,0)),2),'9999999999990.00')),'.',''),15,0) AS REGISTRO_03
           FROM MAPAAPURAC M, MAPARECUP MA, NOTAFISCAL N, IMPOSTONF I, IMPOSTO P, IMPOSTO T
          WHERE M.CDEMPRESA = P_CDEMPRESA
            AND M.CDINSCESTA = P_CDINSCESTA
            AND M.CDIMPOSTO = T.CDIMPOSTONFE
            AND T.CDIMPOSTO = V_CDIMPOSTRIB
            AND M.DTINIPERIODO >= P_DTINICIAL
            AND M.DTFIMPERIODO <= P_DTFINAL
            AND M.NRSEQUMAPAPU = MA.NRSEQUMAPAPU
            AND M.NRSEQUMAPAPU = I.NRSEQUMAPAPU
            AND I.CDFILIAL = N.CDFILIAL
            AND I.NRLANCTONF = N.NRLANCTONF
            AND I.CDIMPOSTO = T.CDIMPOSTO)LOOP

         V_CONTADOR := NVL(V_CONTADOR,0)+1;
         INSERT INTO ARQMAGNETICO
            (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
            (LPAD(V_CONTADOR, 10, '0'),V_INSERT||C_REGISTRO_03.REGISTRO_03||LPAD(0,30,0),P_SEQMAGNET);
            V_VERIFICA := '1';
      END LOOP;
   END IF;
   IF V_VERIFICA = '0' THEN
      INSERT INTO ARQMAGNETICO
         (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
         (LPAD(V_CONTADOR, 10, '0'),V_INSERT||LPAD(0,105,0)||LPAD(0,30,0),P_SEQMAGNET);

   END IF;

RETURN (TO_CHAR(LPAD(V_CONTADOR, 10, '0')));
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ARQUIVO_GIA_MS_03','5.30.000'); END;
/

